
From: Anton Blanchard <anton@samba.org>

Reduce size of buffer_head from 96 to 88 bytes on 64bit architectures by
putting b_count and b_size together.  b_count will still be in the first 16
bytes on 32bit architectures, so 16 byte cacheline machines shouldnt be
affected.

With this change the number of objects per 4kB slab goes up from 40 to 44
on ppc64.

Signed-off-by: Anton Blanchard <anton@samba.org>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/include/linux/buffer_head.h |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

diff -puN include/linux/buffer_head.h~reduce-size-of-struct-buffer_head-on-64bit include/linux/buffer_head.h
--- 25/include/linux/buffer_head.h~reduce-size-of-struct-buffer_head-on-64bit	2004-08-15 17:38:35.929892024 -0700
+++ 25-akpm/include/linux/buffer_head.h	2004-08-15 17:38:35.934891264 -0700
@@ -49,12 +49,12 @@ typedef void (bh_end_io_t)(struct buffer
 struct buffer_head {
 	/* First cache line: */
 	unsigned long b_state;		/* buffer state bitmap (see above) */
-	atomic_t b_count;		/* users using this block */
 	struct buffer_head *b_this_page;/* circular list of page's buffers */
 	struct page *b_page;		/* the page this bh is mapped to */
+	atomic_t b_count;		/* users using this block */
+	u32 b_size;			/* block size */
 
 	sector_t b_blocknr;		/* block number */
-	u32 b_size;			/* block size */
 	char *b_data;			/* pointer to data block */
 
 	struct block_device *b_bdev;
_
